//+------------------------------------------------------------------
//|                                                  double BB ea.mq5 
//+------------------------------------------------------------------
#property copyright "mladen && doc"
#property link      "www.forex-tsd.com"

#include <Trade\Trade.mqh>

//--- input parameters
input string               Expert_Name      = "---- Double BB ea ----";
input int                  bands_period     =             20; // period of moving average
input int                  bands_shift      =              0; // shift
input double               deviation        =            2.0; // number of standard deviations 
input ENUM_APPLIED_PRICE   applied_price    =    PRICE_CLOSE; // type of price
input ENUM_TIMEFRAMES      period           = PERIOD_CURRENT; // timeframe
input int                  bands_period2    =             40; // period2 of moving average
input double               deviation2       =            3.0; // 2nd number of standard deviations 
input string               MM_inputs        = "---- MoneyManagement ----";
input double               Lots             =            0.1; // Lots to trade (if fixed lots size used)
input double               Risk             =              0; // Rsik % (if variable lots size used)
input double               StopLossPips     =             40; // Stop loss in pips 
input double               RiskRewardRatio  =            3.0; // Risk reward ratio
input int                  maxspread        =             10; // Max spread
input double               MinPips          =             10; // Min Pips to Win
input string               Time_Inputs      = "---- Timing parameters ----";
input uint                 StartHour        =              0; // Start hour
input uint                 StartMinute      =              0; // Start minute
input uint                 EndHour          =             24; // Ending hour
input uint                 EndMinute        =              0; // Ending minute


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
double   _point;
double   _spread;
int OnInit()
{
   _point   = _Point*MathPow(10,_Digits%2);
   _spread  = maxspread*MathPow(10,_Digits%2);
   return(0);
}
void OnDeinit(const int reason)
{
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _doNothing   0
#define _doOpenBuy   1
#define _doOpenSell  2
#define _doCloseBuy  3
#define _doCloseSell 4


bool checkTimeLimits(uint startHour, uint endHour, datetime timeToCheck) { return(checkTimeLimits(startHour,0,0,endHour,0,0,timeToCheck)); }
bool checkTimeLimits(uint startHour, uint startMinute, uint endHour, uint endMinute, datetime timeToCheck) { return(checkTimeLimits(startHour,startMinute,0,endHour,endMinute,0,timeToCheck)); }
bool checkTimeLimits(uint startHour, uint startMinute, uint startSecond, uint endHour, uint endMinute, uint endSecond, datetime timeToCheck)
{
   bool answer = false;
   MqlDateTime tempTime; TimeToStruct(timeToCheck,tempTime);
      datetime startTime,endTime,checkTime;
               startTime = _ctMinMax(startHour,0,24)    *3600+_ctMinMax(startMinute,0,60) *60+_ctMinMax(startSecond,0,60);
               endTime   = _ctMinMax(endHour,0,24)      *3600+_ctMinMax(endMinute,0,60)   *60+_ctMinMax(endSecond,0,60);
               checkTime = _ctMinMax(tempTime.hour,0,24)*3600+_ctMinMax(tempTime.min,0,60)*60+_ctMinMax(tempTime.sec,0,60);
               
   if (startTime>endTime)
          answer = (checkTime>=startTime || checkTime<=endTime);
   else   answer = (checkTime>=startTime && checkTime<=endTime);
   return(answer);
}
uint _ctMinMax(uint value, uint min, uint max) { return((uint)MathMax(MathMin(value,max),min)); }



//start -1 short 0 long 1

int getLastOrderType(string forSymbol)
{
   if (HistorySelect(0,TimeCurrent()))
   {        
      int  totalPastOrders = HistoryOrdersTotal();
      uint lastOrderType   = -1;
      while(totalPastOrders>0 && !IsStopped())
      {
         ulong ticket = HistoryOrderGetTicket(totalPastOrders-1);
           if (ticket > 0 && (string)HistoryOrderGetString(ticket,ORDER_SYMBOL)==forSymbol) 
           {
               lastOrderType = (uint)HistoryOrderGetInteger(ticket,ORDER_TYPE); break;
           }
           else totalPastOrders--;
      }
      return((int)lastOrderType);
   }               
   return(-1);
}  


double TotalProfit(int mode)
{
   int total = PositionsTotal();
   double profit = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   string sSymbol=PositionGetSymbol(cnt);
      if(PositionSelect(sSymbol) == true && sSymbol == _Symbol) 
      {
      double open  = PositionGetDouble(POSITION_PRICE_OPEN);
      double close = PositionGetDouble(POSITION_PRICE_CURRENT);
      
         if(mode == 1)
         {
         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY ) profit = (close - open)/_point;
         else
         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL) profit = (open - close)/_point;
         }
         else
         profit = PositionGetDouble(POSITION_PROFIT) + PositionGetDouble(POSITION_SWAP) + PositionGetDouble(POSITION_COMMISSION);
      }
   }
    
   return(profit);
}



void OnTick()
{
   if(PositionSelect(_Symbol)) ManageOpened();
   else                        CheckForOpen();
}

//
//
//
//
//
   
   
void ManageOpened()
{

   int doWhat = checkExit(); Print(doWhat); if (doWhat==_doNothing) return;
   //
   //
   //
   //


      if (PositionSelect(_Symbol))
      if ((doWhat==_doCloseBuy  && PositionGetInteger(POSITION_TYPE) == ORDER_TYPE_BUY ) ||
          (doWhat==_doCloseSell && PositionGetInteger(POSITION_TYPE) == ORDER_TYPE_SELL))
          {
            CTrade trade;
                   trade.PositionClose(_Symbol);
          }                      
}

void CheckForOpen()
{
   int doWhat = checkEntry(); if (doWhat==_doNothing) return;

   //
   //
   //
   //
   //
   
      int    digits = (int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
      double point  = (double)SymbolInfoDouble(_Symbol,SYMBOL_POINT);
      double pip    = point; if (digits==3 || digits==5) pip = point*10.0;

      //
      //
      //
      //
      //
            
                  
      ENUM_ORDER_TYPE signal=-1;
      if (doWhat==_doOpenBuy)  signal = ORDER_TYPE_BUY;
      if (doWhat==_doOpenSell) signal = ORDER_TYPE_SELL;
      
      if (TerminalInfoInteger(TERMINAL_TRADE_ALLOWED))
      {
         double sl,tp,bp;
            if (doWhat==_doOpenBuy)
            {
               bp = (double)SymbolInfoDouble(_Symbol,SYMBOL_ASK);
               sl = bp-StopLossPips*pip;
               tp = bp+StopLossPips*pip*RiskRewardRatio;
            }
            if (doWhat==_doOpenSell)
            {
               bp = (double)SymbolInfoDouble(_Symbol,SYMBOL_BID);
               sl = bp+StopLossPips*pip;
               tp = bp-StopLossPips*pip*RiskRewardRatio;
            }
      
            //
            //
            //
            //
            //
         
         CTrade trade;
                trade.PositionOpen(_Symbol,signal,getLots(Lots,Risk,StopLossPips*pip),SymbolInfoDouble(_Symbol,signal==ORDER_TYPE_SELL ? SYMBOL_BID:SYMBOL_ASK),sl,tp);
      }
}

//
//
//
//
//

int checkEntry()
{
   //--- get current Bid
   double curBidVal=SymbolInfoDouble(Symbol(),SYMBOL_BID);
   
   //--- get current Spread
   int spread=int(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD));
   
   //--- time filter
   bool timecond = checkTimeLimits(StartHour,StartMinute,EndHour,EndMinute,TimeCurrent());
   
   if (PositionSelect(_Symbol)) return(_doNothing);

   //
   //
   //
   //
   //
   static int handle_BB = 0;
          if (handle_BB == 0) handle_BB = iBands(_Symbol,period,bands_period,bands_shift,deviation,applied_price);
          if (handle_BB == INVALID_HANDLE) return(_doNothing);
          //
          //
          //
          //
          //
          
          double upenvelope[3],dnenvelope[3];
          
               if (CopyBuffer(handle_BB,1,0,3,upenvelope)!=3)                                                  return(_doNothing);
               if (CopyBuffer(handle_BB,2,0,3,dnenvelope)!=3)                                                  return(_doNothing);
               if ((curBidVal>=upenvelope[0])&&(spread<=_spread)&& timecond && getLastOrderType(_Symbol)!=1)   return(_doOpenBuy);
               if ((curBidVal<=dnenvelope[0])&&(spread<=_spread)&& timecond && getLastOrderType(_Symbol)!=0)   return(_doOpenSell);
                                                                                                               return(_doNothing);
}


int checkExit()
{
   //--- get current Bid
   double curBidVal=SymbolInfoDouble(Symbol(),SYMBOL_BID);
   
   //--- get current Spread
   int spread=int(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD));  
   
   double pips = TotalProfit(1); 

   
   if (!PositionSelect(_Symbol)) return(_doNothing); // no exit if there is no open position

   //
   //
   //
   //
   //

 static int handle_BB = 0;
          if (handle_BB == 0) handle_BB = iBands(_Symbol,period,bands_period2,bands_shift,deviation2,applied_price);
          if (handle_BB == INVALID_HANDLE) return(_doNothing);
          //
          //
          //
          //
          //
          
          double upenvelope[3],dnenvelope[3];
          
               if (CopyBuffer(handle_BB,1,0,3,upenvelope)!=3)                                                    return(_doNothing);
               if (CopyBuffer(handle_BB,2,0,3,dnenvelope)!=3)                                                    return(_doNothing);
               if (((curBidVal>=upenvelope[0])&&(spread<=_spread))||((pips>=MinPips)&&(spread<=_spread)))        return(_doCloseSell);
               if (((curBidVal<=dnenvelope[0])&&(spread<=_spread))||((pips>=MinPips)&&(spread<=_spread)))        return(_doCloseBuy);
                                                                                                                 return(_doNothing);
                                                                                             
}
//----------------------------------------------------------------------------------------
//                                 
//----------------------------------------------------------------------------------------
//
//
//
//
//
//
//

double getLots(double BaseLot, double risk, double stopLossDistance)
{
   double TickValue = SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE);
   double MinLots   = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN) ,2);
   double MaxLots   = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX) ,2);
   double LotStep   = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP),2);
   double lots      = BaseLot;
   int    LotDigit;

      if (LotStep==1)    LotDigit=0;
      if (LotStep==0.1)  LotDigit=1;
      if (LotStep==0.01) LotDigit=2;
      if (risk>0 && stopLossDistance>0)
      {
         if (AccountInfoDouble(ACCOUNT_BALANCE)>AccountInfoDouble(ACCOUNT_FREEMARGIN))
               lots = NormalizeDouble(AccountInfoDouble(ACCOUNT_FREEMARGIN)*(risk/100.0)/(stopLossDistance*TickValue/_Point),LotDigit);
         else  lots = NormalizeDouble(AccountInfoDouble(ACCOUNT_BALANCE)   *(risk/100.0)/(stopLossDistance*TickValue/_Point),LotDigit);
      }      
   return(MathMax(MathMin(lots,MaxLots),MinLots));   
}

